@file:JvmName("_UpsertColumnKt")

package ru.landgrafhomyak.db.serdha0.user_commons.construction

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.serdha0.api.misc.Column
import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.db.serdha0.api.misc.QueryParam
import ru.landgrafhomyak.db.serdha0.api.queries.InsertQuery
import ru.landgrafhomyak.db.serdha0.api.queries.UpdateQuery


public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> InsertQuery.SingleRow.Constructor.Scope<qUE, ocUE>.insertParamToColumn(
	paramName: String, column0: Column<RT, DT, ocUE>, vararg columnN: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> {
	val param = this.queryParam(paramName, column0.type)
	this.insertParam(column0, param)
	for (column in columnN)
		this.insertParam(column, param)
	return param
}

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> InsertQuery.FromSubquery.Constructor.Scope<qUE, ocUE, *>.insertParamToColumn(
	paramName: String, column0: Column<RT, DT, ocUE>, vararg columnN: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> {
	val param = this.queryParam(paramName, column0.type)
	this.insertParam(column0, param)
	for (column in columnN)
		this.insertParam(column, param)
	return param
}

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> InsertQuery.MultipleRows.Constructor.Scope<qUE, ocUE>.insertParamToColumn(
	paramName: String, column0: Column<RT, DT, ocUE>, vararg columnN: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> {
	val param = this.inputColumn(paramName, column0.type)
	this.insertColumn(column0, param)
	for (column in columnN)
		this.insertColumn(column, param)
	return param
}

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> UpdateQuery.SingleRow.Constructor.Scope<qUE, ocUE>.updateColumnWithParam(
	paramName: String, column0: Column<RT, DT, ocUE>, vararg columnN: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> {
	val param = this.queryParam(paramName, column0.type)
	this.updateColumnWithParam(column0, param)
	for (column in columnN)
		this.updateColumnWithParam(column, param)
	return param
}

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> UpdateQuery.FromSubquery.Constructor.Scope<qUE, ocUE, *>.updateColumnWithParam(
	paramName: String, column0: Column<RT, DT, ocUE>, vararg columnN: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> {
	val param = this.queryParam(paramName, column0.type)
	this.updateColumnWithParam(column0, param)
	for (column in columnN)
		this.updateColumnWithParam(column, param)
	return param
}

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> UpdateQuery.MultipleRows.Constructor.Scope<qUE, ocUE>.updateColumnWithParam(
	paramName: String, column0: Column<RT, DT, ocUE>, vararg columnN: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> {
	val param = this.inputColumn(paramName, column0.type)
	this.updateColumnWithParam(column0, param)
	for (column in columnN)
		this.updateColumnWithParam(column, param)
	return param
}
