@file:OptIn(LowLevelApi::class)
@file:JvmName("_Rows2VoidKt")
@file:Suppress("DuplicatedCode")

package ru.landgrafhomyak.db.serdha0.user_commons.executors

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.serdha0.api.LowLevelApi
import ru.landgrafhomyak.db.serdha0.api.queries._Query
import ru.landgrafhomyak.db.serdha0.api.runtime.Transaction

public suspend inline fun <qUE : Any, E> Transaction.mapToRows(
	compiledQuery: _Query.Table2Void<qUE>,
	collection: Iterable<E>,
	transform: RowProducer1<qUE, E>
) {
	_safeAutoClose_I(
		iRow = this._executeQuery(compiledQuery),
		inputAction = { iRow ->
			for (elem in collection) {
				iRow._next()
				transform.transformToRow(iRow, elem)
			}
		}
	)
}

public suspend inline fun <qUE : Any, E> Transaction.mapToRowsIndexed(
	compiledQuery: _Query.Table2Void<qUE>,
	collection: Iterable<E>,
	firstIndex: Int = 0,
	transform: RowProducer2<qUE, E>
) {
	_safeAutoClose_I(
		iRow = this._executeQuery(compiledQuery),
		inputAction = { iRow ->
			var index = firstIndex
			for (elem in collection) {
				iRow._next()
				transform.transformToRow(iRow, index++, elem)
			}
		}
	)
}

public suspend inline fun <qUE : Any, E> Transaction.mapToRows(
	compiledQuery: _Query.Table2Void<qUE>,
	sequence: Sequence<E>,
	transform: RowProducer1<qUE, E>
) {
	_safeAutoClose_I(
		iRow = this._executeQuery(compiledQuery),
		inputAction = { iRow ->
			for (elem in sequence) {
				iRow._next()
				transform.transformToRow(iRow, elem)
			}
		}
	)
}

public suspend inline fun <qUE : Any, E> Transaction.mapToRowsIndexed(
	compiledQuery: _Query.Table2Void<qUE>,
	sequence: Sequence<E>,
	firstIndex: Int = 0,
	transform: RowProducer2<qUE, E>
) {
	_safeAutoClose_I(
		iRow = this._executeQuery(compiledQuery),
		inputAction = { iRow ->
			var index = firstIndex
			for (elem in sequence) {
				iRow._next()
				transform.transformToRow(iRow, index++, elem)
			}
		}
	)
}

public suspend inline fun <qUE : Any, E> Transaction.mapToRows(
	compiledQuery: _Query.Table2Void<qUE>,
	array: Array<E>,
	transform: RowProducer1<qUE, E>
) {
	_safeAutoClose_I(
		iRow = this._executeQuery(compiledQuery),
		inputAction = { iRow ->
			for (elem in array) {
				iRow._next()
				transform.transformToRow(iRow, elem)
			}
		}
	)
}

public suspend inline fun <qUE : Any, E> Transaction.mapToRowsIndexed(
	compiledQuery: _Query.Table2Void<qUE>,
	array: Array<E>,
	firstIndex: Int = 0,
	transform: RowProducer2<qUE, E>
) {
	_safeAutoClose_I(
		iRow = this._executeQuery(compiledQuery),
		inputAction = { iRow ->
			var index = firstIndex
			for (elem in array) {
				iRow._next()
				transform.transformToRow(iRow, index++, elem)
			}
		}
	)
}