package ru.landgrafhomyak.db.serdha0.user_commons.types

import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.utility.IntSerializers

@Suppress("ClassName")
@OptIn(ExperimentalUnsignedTypes::class)
public class S_INT_16(context: DatabaseType.Provider) : DatabaseType._VirtualType<Short, UByteArray, DatabaseType.BINARY_DATA>(
	wraps = context.BINARY_DATA(2u, true),
	allowValuesCaching = true
) {
	override val name: String = "S_INT_16"

	override fun _unwrap(w: UByteArray): Short {
		return IntSerializers.decode16beH(w, 0)
	}

	override fun _wrap(w: Short): UByteArray {
		return IntSerializers.encode16beH(UByteArray(2), 0, w)
	}

	override fun _equals(l: Short, r: Short): Boolean {
		return l == r
	}

	override fun _compare(l: Short, r: Short): Int {
		return l.compareTo(r)
	}

}