package ru.landgrafhomyak.db.serdha0.user_commons.types

import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.utility.IntSerializers

@Suppress("ClassName")
@OptIn(ExperimentalUnsignedTypes::class)
public class U_INT_32(context: DatabaseType.Provider) : DatabaseType._VirtualType<UInt, UByteArray, DatabaseType.BINARY_DATA>(
	wraps = context.BINARY_DATA(4u, true),
	allowValuesCaching = true
) {
	override val name: String = "U_INT_32"

	override fun _unwrap(w: UByteArray): UInt {
		return IntSerializers.decode32beIu(w, 0)
	}

	override fun _wrap(w: UInt): UByteArray {
		return IntSerializers.encode32beIu(UByteArray(4), 0, w)
	}

	override fun _equals(l: UInt, r: UInt): Boolean {
		return l == r
	}

	override fun _compare(l: UInt, r: UInt): Int {
		return l.compareTo(r)
	}

}