package ru.landgrafhomyak.db.serdha0.user_commons.types

import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.utility.IntSerializers

@Suppress("ClassName")
@OptIn(ExperimentalUnsignedTypes::class)
public class U_INT_64(context: DatabaseType.Provider) : DatabaseType._VirtualType<ULong, UByteArray, DatabaseType.BINARY_DATA>(
	wraps = context.BINARY_DATA(8u, true),
	allowValuesCaching = true
) {
	override val name: String = "U_INT_64"

	override fun _unwrap(w: UByteArray): ULong {
		return IntSerializers.decode64beLu(w, 0)
	}

	override fun _wrap(w: ULong): UByteArray {
		return IntSerializers.encode64beLu(UByteArray(8), 0, w)
	}

	override fun _equals(l: ULong, r: ULong): Boolean {
		return l == r
	}

	override fun _compare(l: ULong, r: ULong): Int {
		return l.compareTo(r)
	}

}